unit Menu_;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ADODB, Grids, DBGrids, DB, StdCtrls, Menus;

Type
  TForm1 = class(TForm)
    ADOQuery1: TADOQuery;
    Qmenu: TADOQuery;
    MainMenu1: TMainMenu;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
    function CheckPermission(USER_ID: String; FUN:String ; var permission:String): Boolean;
    function TreeID2Caption(FunID: String): String;
    function OpenMenuFunction(FunName: String;MenuItem: TmenuItem=nil):Boolean;
    procedure ADDMenuItem(MItem: TmenuItem; Name,Hint,Caption: String; Tag: Integer; Action:TNotifyEvent);
    procedure OpenMenuItem(Sender: TObject);
  public
    { Public declarations }
    function CreateMenu: Boolean;
  end;

var
  user_id,permission: String;
  Form1: TForm1;
implementation

uses yachangaVCL;

{$R *.dfm}


function TForm1.CreateMenu: Boolean;
begin
 Result:=False;
 try
  With Qmenu do
   begin
    MainMenu1.Items.Clear;
    SQL.Clear;
    SQL.ADD('Select  a.tree_id,a.tree_name,a.func_id,a.seq');
    SQL.ADD('   from  tree.txt a,userfunc.txt b');
    SQL.ADD(' where a.func_id=b.func_id ');
    SQL.ADD('   and b.user_id='''+user_id+'''');
    SQL.ADD('order by seq');
    OPEN;

  // øs
    first;
    while not eof do
     begin
      AddMenuItem(MainMenu1.Items,Fieldbyname('TREE_ID').AsString,
               Fieldbyname('FUNC_ID').AsString,
               Fieldbyname('TREE_NAME').AsString,0,OpenMenuItem);
      next;
     end;
    close;
   end;
  result:=true;
 except
  result:=false;
 end;
end;


procedure TForm1.ADDMenuItem(MItem: TmenuItem; Name, Hint, Caption: String;
  Tag: Integer; Action: TNotifyEvent);
var
  ilevel,maxLevel:Integer;
  strItem,tItem: String;
  CurMenu,tmpItem: Tmenuitem;
begin
 strItem:=Name;
 maxLevel:=GetFunLevel(strItem);
 CurMenu:=MItem;
 iLevel:=1;
  while iLevel <= maxLevel do
   begin
     if iLevel < maxLevel then
      tItem:=ParentName(iLevel,strItem)
     else
      tItem :=strItem;

     tmpItem:=FindItem(CurMenu,tItem);
     if tmpItem is TmenuItem then
       tmpItem.OnClick:=nil
     else
      begin
       if iLevel=maxLevel then
        begin
         if not InsertItem(CurMenu,name,hint,caption,tag,OpenMenuItem) then
          Showmessage('Ӷ ' + tItem +' ->'+caption+ ' LkJ');
        end
       else
        begin
         if TreeID2Caption(tItem)<>'' then
          begin
           if not InsertItem(CurMenu,tItem,'',TreeID2Caption(tItem),0,nil) then
            Showmessage('ؿ ' + tItem +' ->'+caption+ ' LkJ');
          end
         else
          break;
        end;
      end;
    ilevel:=ilevel+1;
    CurMenu:=FindItem(CurMenu,tItem);
   end;
end;


procedure TForm1.OpenMenuItem(Sender: TObject);
begin
 With  (Sender as Tmenuitem) do
  OpenMenuFunction(Hint,(Sender as Tmenuitem));
end;


function Tform1.TreeID2Caption(FunID: String): String;
begin
    Result:='';
    with ADOQUERY1 do begin
      SQL.clear;
      sql.add (' select tree_id,tree_name,func_id');
      sql.add ('          from tree.txt a ');
      sql.add ('         where tree_id='''+FunID+'''');

      OPEN;
      Result:=Fieldbyname('TREE_NAME').AsString;
    end;
end;

function Tform1.OpenMenuFunction(FunName: String;MenuItem: TmenuItem=nil): Boolean;
Var
 sCaption: String;
 FormTemp: Tform;
begin
   //Ūv
   if not CheckPermission(user_id,FunName,permission) then
    begin
     showmessage('zLvϥΦ\,ЫTw}!');
     Abort;
    end;

   // \}
     if MenuItem is TMenuItem then
       sCaption:= MenuItem.Caption;

     FormTemp:= createform('T'+FunName,sCaption,FunName);
     if FormTemp is TFORM then FormTemp.Show;
end;


function TForm1.CheckPermission(USER_ID: String; FUN: String;
  var permission: String): Boolean;
begin
   Result:=true;
   try
    with ADOQUERY1 do begin
      SQL.clear;
      sql.add (' select permission');
      sql.add ('          from userfunc.txt a ');
      sql.add (' where user_id='''+USER_ID+''' and func_id='''+FUN +'''');

      OPEN;
      permission:=Fieldbyname('permission').AsString;
      CLOSE;
    end;
   except
    result:=false;
   end;
end;


procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
Action:=cafree;
end;



end.
